int deweyClass = 0;
float gap = 25;
final float margin_to_left = 160;
boolean reset = false;


boolean[] state = {true, true, true, true, true, true, true, true, true, true};
color clr[] =
{#a7d8bb,
    #ff3b8c,
    #008021,
    #baadff,
    #f9e36b,
    #018ad8,
    #e4bf97,
    #9b9999,
    #e2b3c7,
#fefed3};


String[] deweyClasses = {"Computer science, information and general work", "Philosophy and psychology",
    "Religion", "Social sciences","Language","Technology","Associations, organizations and museums", 
    "Arts and recreation", "Literature", "History and geography"};

color yearclr[] = {#FF6633, #FFB399, #FF33FF, #FFFF99, #00B3E6, 
    #E6B333, #3366E6, #999966, #99FF99, #B34D4D,
    #80B300, #809900, #E6B3B3, #6680B3, #66991A, 
    #FF99E6, #CCFF1A, #FF1A66, #E6331A, #33FFCC,
    #66994D, #B366CC, #4D8000, #B33300, #CC80CC};

void drawData() {
    for (int i = 0; i < 10; i++) {
        if (state[i]) {
            for (int j = 0; j < 4; j++) {
                pushMatrix();
                translate( -650,0,80);
                rotateY(PI / 2);
                drawPoints(i, j);
                popMatrix();
            }
        }
    }
}

void drawPoints(int deweyClass,int year) {
    ArrayList<Book> curBooks = b1.get(year);
    pushMatrix();
    rotateY( -PI / 2);
    textSize(30);
    if (year > 0) {
        text(2006 + year * 5 ,(rs[year] + rs[year - 1]) / 6 - 100  + 500 * year ,  - rs[year] - 10 , 20);
    } else {
        text(2006 + year * 5 , rs[0] / 6 - 100 ,  - rs[year] - 10 , 20);
    }
    popMatrix();
    for (int i = 0; i < curBooks.size(); i++) {
        float pointSize = map(curBooks.get(i).counts,0, maxs1[year],5,50);
        int cur = curBooks.get(i).deweyClass;
        if (cur == deweyClass) {
            stroke(clr[deweyClass]);
        } 
        else{noStroke();}
        strokeWeight(pointSize);
        pushMatrix();
        //float[] rotations = cam.getRotations();
        translate(curBooks.get(i).x,curBooks.get(i).y, curBooks.get(i).z);
        //rotateX(rotations[0]);
        //rotateY(rotations[1]);
        //rotateZ(rotations[2]);
        point(0,0,0);
        float mouseObjectDis = sq(mouseX - screenX(0, 0, 0)) + sq(mouseY - screenY(0, 0, 0));
        if (mouseObjectDis < 50 && state[cur] == true) {
            strokeWeight(pointSize * 2.5);
            stroke(clr[cur]);
            point(0, 0, 0);
            stroke(#FFFFFF); //<>//
            fill(#FFFFFF);
            //pushMatrix();
            //rotateY(-PI/2);
            textSize(10);
            String curString = curBooks.get(i).title;
            text(curString, 0, 15);
            strokeWeight(pointSize);
            stroke(clr[cur], 255);
            point(0, 0, 0);
            stroke(0, 0, 0, 0);
            //popMatrix();
        }
        popMatrix();
    }
}

void drawYears() {
    for (int i = 2006; i <= 2022; i++) {
        drawCircle(i);
    } 
}

void drawCircle(int year) {
    int curMonth = yearMap.get(year)[1];
    float centerX = (curMonth - 1)  * 100;
    float centerY  = map(yearMap.get(year)[0], 3692, 41989, 100,500); 
    float centerZ = map(yearMap.get(year)[2], 841, 4120, 200, 600);
    float r = map(yearMap.get(year)[0], 3692, 41989, 50,200);
    
    int numPoints = 50;
    float angleIncrement = TWO_PI / numPoints;
    
    
    stroke(yearclr[year - 2006]);
    pushMatrix();
    translate(centerX, centerY, centerZ);
    //sphere(5);
    strokeWeight(5);
    point(0,0,0);
    fill(yearclr[year - 2006]);
    textAlign(CENTER);
    textSize(20);
    text(year, 0 , -10, 10);
    popMatrix();
    
    //textSize(20);
    textAlign(LEFT);
    text(yearMap.get(year)[0], centerX +10, centerY, centerZ);
    //strokeWeight(5);
    //line(centerX, centerY, centerZ, centerX, centerY, 0);
    //textSize(20);
    textAlign(LEFT);
    text(yearMap.get(year)[2], centerX, centerY, 0);
    ArrayList<float[]> list = new ArrayList<>();

    for (int i = 0; i < numPoints; i++) {
        //stroke(yearclr[year - 2006]);
        
        float sphereRadius = map(p1.get(year - 2006).get(i).counts,0,maxs[year - 2006],1,5);
        float angle = i * angleIncrement;
        float x = centerX + cos(angle) * r;
        float y = centerY + sin(angle) * r;
        
        list.add(new float[]{x,y});
    }
    
    pushMatrix();
    translate(0,0,centerZ);
    strokeWeight(0.7);
    stroke(yearclr[year - 2006]);
    noFill();
    for (int i = 0; i < list.size(); ++i) {
        int next = i + 1 == list.size() ? 0 : i + 1;
        beginShape(TRIANGLES);
        vertex(list.get(i)[0],list.get(i)[1],-20);
        vertex(centerX,centerY,0);
        vertex(list.get(next)[0], list.get(next)[1],-20);
        endShape();
}
    
    
    popMatrix();
}

void axis() {
    //x-axis: Month
    for (int i = 0; i < months.length; i++) {
        textSize(15);
        fill(255);
        textAlign(CENTER);
        textSize(20);
        text(months[i],i * 100, 670, 0);
        stroke(255);
        strokeWeight(0.4);
        line(i * 100, 0 , 0 , i * 100 , 650 , 0);
    }
    
    //y-axis: checkout number in max month
    rotateZ( -PI / 2);
    textAlign(LEFT);
    text("                                                  checkout number in max month", -650, -30, 0);
    fill(255);
    
    //Z-axis: 
    rotateZ(PI / 2);
    rotateY( -PI / 2);
    textSize(20);
    textAlign(LEFT);
    text("Total Checkout Number", 300 , -10, 0);
    rotateY(PI / 2); 
    line(0,0,0,0,0,600);
    rotateZ( -PI / 2);  
}


void legend() {
    hint(DISABLE_DEPTH_TEST);
    cam.beginHUD();
    cp5.draw();
    
    //plot's legend
    if (plot) {
        for (int i = 0; i < 8; i++) {
            stroke(yearclr[i]);
            strokeWeight(10);
            noFill();
            point(margin_to_left - 125,520 + gap * i);
            fill(255);
            textAlign(LEFT);
            textSize(16);
            pushMatrix();
            translate(0,i * gap,0);
            text(2006 + i ,margin_to_left - 100,525);
            popMatrix();
        }
        
        for (int i = 8; i < 16; i++) {
            stroke(yearclr[i]);
            strokeWeight(10);
            noFill();
            point(margin_to_left - 35 ,520 + gap * (i - 8));
            fill(255);
            textAlign(LEFT);
            textSize(16);
            pushMatrix();
            translate(0,(i - 8) * gap,0);
            text(2006 + i ,margin_to_left - 10,525);
            popMatrix();
        }
        stroke(yearclr[16]);
        strokeWeight(10);
        noFill();
        point(margin_to_left + 55,520);
        fill(255);
        textAlign(LEFT);
        textSize(16);
        pushMatrix();
        translate(0,0 ,0);
        text(2022 ,margin_to_left + 80 ,525);
        popMatrix();
    }
    
    //point's legend
    if (point) {
        for (int i = 0; i < 3; i++) {
            stroke(clr[i]);
            strokeWeight(2);
            if (state[i]) {
                fill(clr[i]);
            } else {
                noFill();
            }
            rect(100 + 400 * i, 600 , 15, 15);
            fill(255);
            textAlign(LEFT);
            textSize(16);
            //pushMatrix();
            //translate(0,0,0);
            text(deweyClasses[i] ,120 + 400 * i ,612.5);
            //popMatrix();
        }
        
        for (int i = 3; i < 6; i++) {
            stroke(clr[i]);
            strokeWeight(2);
            if (state[i]) {
                fill(clr[i]);
            } else {
                noFill();
            }
            rect(100 + 400 * (i - 3), 630 , 15, 15);
            fill(255);
            textAlign(LEFT);
            textSize(16);
            //pushMatrix();
            //translate(0,0,0);
            text(deweyClasses[i] ,120 + 400 * (i - 3) ,642.5);
            //popMatrix();
        }
        
        for (int i = 6; i < 9; i++) {
            stroke(clr[i]);
            strokeWeight(2);
            if (state[i]) {
                fill(clr[i]);
            } else {
                noFill();
            }
            rect(100 + 400 * (i - 6), 660 , 15, 15);
            fill(255);
            textAlign(LEFT);
            textSize(16);
            text(deweyClasses[i] ,120 + 400 * (i - 6) ,672.5);
        }
        
        stroke(clr[9]);
        strokeWeight(2);
        if (state[9]) {
            fill(clr[9]);
        } else {
            noFill();
        }
        rect(100, 690 , 15, 15);
        fill(255);
        textAlign(LEFT);
        textSize(16);
        text(deweyClasses[9] ,120,702.5);
    }
    
    //reset & overview mode
    stroke(#9b9999);
    strokeWeight(2);
    fill(#9b9999);
    rect(1100, 100 , 90, 20);
    fill(255);
    textAlign(LEFT);
    textSize(20);
    text("Reset" ,1120, 115);
    
    //overview: show all class
    if (point) {
        stroke(#9b9999);
        strokeWeight(2);
        fill(#9b9999);
        rect(1100, 130 , 90, 20);
        fill(255);
        textAlign(LEFT);
        textSize(20);
        text("Overview" ,1105, 145);
    }
    
    //title
    pushMatrix();
    textAlign(LEFT);
    translate(0, gap,0);
    textSize(15);
    text("Chinese Related Books Interests at \n Seattle Public Library(2006 - 2022) \n MAT 259 | Zeyu Wang" ,10,30);
    textAlign(RIGHT);
    text("1 - show relationship plot", 1250,655);
    text("2 - show point view of popular items", 1250, 675);
    popMatrix();
    
    cam.endHUD();
    hint(ENABLE_DEPTH_TEST);
}


