/*************************************************************************************
Mat 259 : Project 2 3D Visualization
 "Chinese Related Books Interests at Seattle Public Library (2006 - 2022)"
 
Tested in Processing 4.1.2                                    
                                                     
Author: Zeyu Wang                                              

Purpose: Show how to present volume data in a basic 3D environment   
Reference: Part of the code referred from Meilin Shi 

Usage: 1. Show a plot to describle the relationship between checkout number and year & month, find top 50 popular books.
       2. Show a point view of popular books over time and show a trend in every 5 years.
       3. Press '1' to show plot view.
       4. Press '2' to show point view.
       5. Click 'Reset' to reset camera to its starting settings 
       6. Click 'Overview' to show all deweyClass result in point views.
       7. Click each rect in point legend to show/hide current deweyClass's point view.
*************************************************************************************/
import peasy.*;
import controlP5.*;

PeasyCam cam;
ControlP5 cp5;

void setup() {
  size(1280,720,P3D);
  cam = new PeasyCam(this, 1000);
  cp5 = new ControlP5(this);
  smooth(8);
  read();
}

void draw() {
  background(40);
  
  
 
  textMode(SHAPE);
  colorMode(HSB);
  if(plot) {
    pushMatrix();
    translate(-400, 0, -500);
    rotateX(PI/4);
      drawYears();
      axis();
    popMatrix();
  } 
  if(point) {
    drawData();
  }
  legend();
}
