select 
YEAR(cout) AS years,
count(IF(deweyClass >= 000 and deweyClass < 100, 1, NULL)) AS 'Computer science, information and general works',
count(IF(deweyClass >= 100 and deweyClass < 200, 1, NULL)) AS 'Philosophy and psychology',
count(IF(deweyClass >= 200 and deweyClass < 300, 1, NULL)) AS 'Religion',
count(IF(deweyClass >= 300 and deweyClass < 400, 1, NULL)) AS 'Social sciences',
count(IF(deweyClass >= 400 and deweyClass < 500, 1, NULL)) AS 'Language',
count(IF(deweyClass >= 500 and deweyClass < 600, 1, NULL)) AS 'Technology',
count(IF(deweyClass >= 600 and deweyClass < 700, 1, NULL)) AS 'Associations, organizations and museums',
count(IF(deweyClass >= 700 and deweyClass < 800, 1, NULL)) AS 'Arts and recreation',
count(IF(deweyClass >= 800 and deweyClass < 900, 1, NULL)) AS 'Literature',
count(IF(deweyClass >= 900 and deweyClass < 1000, 1, NULL)) AS 'History and geography'
from
(SELECT  distinct id,barcode,itemNumber,itemtype, title, cout, deweyClass
FROM spl_2016.outraw
inner JOIN spl_2016.subject ON outraw.bibNumber = subject.bibNumber
where subject.subject like '%chinese' or subject.subject like '%china%') as A 
where YEAR(cout) = 2006 and deweyClass != ''
-- where YEAR(cout) not in (2023) and deweyClass != ''
GROUP BY YEAR(cout)
ORDER BY YEAR(cout) DESC;

select 
COUNT(title) AS Counts, title,
case when deweyclass >= 900 and deweyclass < 1000 then 900 else deweyclass end 
from (SELECT  distinct id,barcode,itemNumber,itemtype, title, cout, deweyClass
FROM spl_2016.outraw
inner JOIN spl_2016.subject ON outraw.bibNumber = subject.bibNumber
where subject.subject like '%chinese' or subject.subject like '%china%') as A 
WHERE YEAR(cout) = 2006 and deweyClass >= 900 and deweyClass < 1000
group by title, deweyclass 
ORDER BY Counts DESC
LIMIT 50;


SELECT 
    COUNT(title) AS Counts, 
    title, 
    deweyclass
FROM 
    (
        SELECT 
            DISTINCT id, barcode, itemNumber, itemtype, title, cout, 
            CASE 
                WHEN deweyclass > 000 and deweyclass < 100 THEN 0
                WHEN deweyclass >= 100 and deweyclass < 200 THEN 1
                WHEN deweyclass >= 200 and deweyclass < 300 THEN 2
                WHEN deweyclass >= 300 and deweyclass < 400 THEN 3
                WHEN deweyclass >= 400 and deweyclass < 500 THEN 4
                WHEN deweyclass >= 500 and deweyclass < 600 THEN 5
                WHEN deweyclass >= 600 and deweyclass < 700 THEN 6
                WHEN deweyclass >= 700 and deweyclass < 800 THEN 7
                WHEN deweyclass >= 800 and deweyclass < 900 THEN 8
                WHEN deweyclass >= 900 and deweyclass < 1000 THEN 9
                ELSE deweyclass 
            END AS deweyclass 
        FROM spl_2016.outraw
        INNER JOIN spl_2016.subject ON outraw.bibNumber = subject.bibNumber
        WHERE subject.subject LIKE '%chinese' OR subject.subject LIKE '%china%'
    ) AS A 
WHERE YEAR(cout) = 2006 and deweyclass != ''
GROUP BY title, deweyclass 
ORDER BY Counts DESC
LIMIT 50;